/**
* Copyright (c) 2019 The Nuinalp Authors. All rights reserved.
* Use of this source code is governed by a BSD-style license that can be
* found in the LICENSE file.
*/

.nv-slider {
  cursor: grab;
  display: flex;
  flex: 1;
  height: 36px;
  position: relative;
  touch-action: pan-y;
  width: 100%;
  
  .nv-slider-bars {
    height: 100%;
    left: 0;
    overflow: hidden;
    pointer-events: none;
    position: absolute;
    top: 0;
    width: 100%;

    .nv-slider-ticks {
      height: 100%;
      left: 0;
      overflow: hidden;
      position: absolute;
      top: 0;
      width: 100%;
      z-index: 1;

      .nv-slider-tick {
        @extend .transition-entrance;
        background-color: #{$theme-dark-1};
        height: 2px;
        position: absolute;
        top: 50%;
        transform: translateY(-50%);
        width: 2px;

        &:last-child {
          margin-left: -3px;
        }
      }
    }
  }

  &.nv-slider-with-snaps {
    margin: 20px 0;
  }

  .nv-slider-bar {
    @extend .transition-entrance;
    background-color: var(--nv-border-color);
    height: 1px;
    position: absolute;
    right: 0;
    top: 50%;
    transform: translateY(-50%);
    transition-property: background-color, margin-left, margin-right, height;
    width: 100%;
  }

  .nv-slider-bar-active {
    @extend .transition-entrance;
    background-color: #{$theme-dark-1};
    height: 1px;
    left: 0;
    position: absolute;
    top: 50%;
    transform: translateY(-50%);
    transition-property: background-color, margin-right, margin-right, height;
    width: 0%;
  }

  .nv-slider-knob-handle {
    align-items: center;
    display: flex;
    height: 36px;
    justify-content: center;
    left: 0;
    // stylelint-disable-next-line
    margin-inline-start: calc(0px - 36px / 2);
    outline: none;
    pointer-events: none;
    position: absolute;
    top: 50%;
    transform: translateY(-50%);
    width: 36px;
    z-index: 2;

    .nv-slider-knob {
      @extend .transition-entrance;
      background-color: #{$theme-dark-1};
      border-radius: 50%;
      height: 20px;
      pointer-events: none;
      transition-property: width, height, background-color;
      width: 20px;

    }
    
    .nv-slider-snap {
      @extend .transition-exit;
      opacity: 0;
      pointer-events: none;
      position: absolute;
      top: 0%;
      user-select: none;   
    }

    &.nv-slider-knob-pressed {
      .nv-slider-snap {
        @extend .transition-entrance;
        opacity: 1;
        top: -50%;
      }

      .nv-slider-knob {
        background-color: var(--nv-theme-primary-dark-alt);
        height: 26px;
        width: 26px;
      }
    }
  }

  &.nv-slider-salt-animation {
    .nv-slider-knob-handle {
      @extend .transition-entrance;
      transition-property: left, height;
    }

    .nv-slider-bar,
    .nv-slider-bar-active {
      transition-property: width, height, margin-left, margin-right, left;
    }
  }

  &.nv-slider-disabled {
    cursor: default;
    opacity: 0.55;
  }

  &.nv-slider-active {
    .nv-slider-bar-active {
      background-color: var(--nv-theme-primary);
      margin-left: -10px;
    }

    .nv-slider-bar {
      margin-right: -10px;
    }

    .nv-slider-bar,
    .nv-slider-bar-active {
      height: 2px;
    }

    .nv-slider-bars .nv-slider-ticks .nv-slider-tick {
      height: 4px;
      width: 4px;
    }
  }

  &.nv-slider-dual-knobs {
    .nv-slider-bar-active {
      margin-left: unset;
      transition-property: width, height, margin-left, margin-right, left, right;
    }
  }
}
